// Package discoverserviceapi provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen version v1.9.1 DO NOT EDIT.
package discoverserviceapi

import (
	"bytes"
	"compress/gzip"
	"encoding/base64"
	"fmt"
	"net/http"
	"net/url"
	"path"
	"strings"

	"github.com/deepmap/oapi-codegen/pkg/runtime"
	"github.com/getkin/kin-openapi/openapi3"
	"github.com/labstack/echo/v4"
	externalRef0 "oransc.org/nonrtric/plt/capif/internal/readonly/common"
	externalRef1 "oransc.org/nonrtric/plt/capif/internal/readonly/common29571"
	externalRef2 "oransc.org/nonrtric/plt/capif/internal/readonly/publishserviceapi"
)

// ServerInterface represents all server handlers.
type ServerInterface interface {

	// (GET /allServiceAPIs)
	GetAllServiceAPIs(ctx echo.Context, params GetAllServiceAPIsParams) error
}

// ServerInterfaceWrapper converts echo contexts to parameters.
type ServerInterfaceWrapper struct {
	Handler ServerInterface
}

// GetAllServiceAPIs converts echo context to params.
func (w *ServerInterfaceWrapper) GetAllServiceAPIs(ctx echo.Context) error {
	var err error

	// Parameter object where we will unmarshal all parameters from the context
	var params GetAllServiceAPIsParams
	// ------------- Required query parameter "api-invoker-id" -------------

	err = runtime.BindQueryParameter("form", true, true, "api-invoker-id", ctx.QueryParams(), &params.ApiInvokerId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter api-invoker-id: %s", err))
	}

	// ------------- Optional query parameter "api-name" -------------

	err = runtime.BindQueryParameter("form", true, false, "api-name", ctx.QueryParams(), &params.ApiName)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter api-name: %s", err))
	}

	// ------------- Optional query parameter "api-version" -------------

	err = runtime.BindQueryParameter("form", true, false, "api-version", ctx.QueryParams(), &params.ApiVersion)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter api-version: %s", err))
	}

	// ------------- Optional query parameter "comm-type" -------------

	err = runtime.BindQueryParameter("form", true, false, "comm-type", ctx.QueryParams(), &params.CommType)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter comm-type: %s", err))
	}

	// ------------- Optional query parameter "protocol" -------------

	err = runtime.BindQueryParameter("form", true, false, "protocol", ctx.QueryParams(), &params.Protocol)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter protocol: %s", err))
	}

	// ------------- Optional query parameter "aef-id" -------------

	err = runtime.BindQueryParameter("form", true, false, "aef-id", ctx.QueryParams(), &params.AefId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter aef-id: %s", err))
	}

	// ------------- Optional query parameter "data-format" -------------

	err = runtime.BindQueryParameter("form", true, false, "data-format", ctx.QueryParams(), &params.DataFormat)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter data-format: %s", err))
	}

	// ------------- Optional query parameter "api-cat" -------------

	err = runtime.BindQueryParameter("form", true, false, "api-cat", ctx.QueryParams(), &params.ApiCat)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter api-cat: %s", err))
	}

	// ------------- Optional query parameter "supported-features" -------------

	err = runtime.BindQueryParameter("form", true, false, "supported-features", ctx.QueryParams(), &params.SupportedFeatures)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter supported-features: %s", err))
	}

	// ------------- Optional query parameter "api-supported-features" -------------

	err = runtime.BindQueryParameter("form", true, false, "api-supported-features", ctx.QueryParams(), &params.ApiSupportedFeatures)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter api-supported-features: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetAllServiceAPIs(ctx, params)
	return err
}

// This is a simple interface which specifies echo.Route addition functions which
// are present on both echo.Echo and echo.Group, since we want to allow using
// either of them for path registration
type EchoRouter interface {
	CONNECT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	DELETE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	GET(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	HEAD(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	OPTIONS(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PATCH(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	POST(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PUT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	TRACE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
}

// RegisterHandlers adds each server route to the EchoRouter.
func RegisterHandlers(router EchoRouter, si ServerInterface) {
	RegisterHandlersWithBaseURL(router, si, "")
}

// Registers handlers, and prepends BaseURL to the paths, so that the paths
// can be served under a prefix.
func RegisterHandlersWithBaseURL(router EchoRouter, si ServerInterface, baseURL string) {

	wrapper := ServerInterfaceWrapper{
		Handler: si,
	}

	router.GET(baseURL+"/allServiceAPIs", wrapper.GetAllServiceAPIs)

}

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/7xXy3LbuBL9lS7cu0iqaFKSH7nWTteWU5qFozGV2SQpFwQ2RSQgwACgHI1L/+Lt/Ia+",
	"bAoAKcm25ClHqdnYEtnoPn36gaN7wlRZKYnSGtK/J4YVWFL/8ZIbpuaoMRuMR/5JpVWF2nIMpqjnnOFg",
	"PLpEwzSvLFfSv8k230mfbL0FlYMtEJqjMBiPgBqo6qngpsAMpovt9zEMKSseWW+5BlNQIYBLJuoMYTC8",
	"gkqrnAs0UFLLCi5n3lvOhUUNTHOLmtOYRIRbLD3U/2rMSZ9M0t55r9e7vRiMR1e344DnNg2BbwfjUbyg",
	"pfhPsiEraZhK0l00kGVESi5HIUw3InZRIekTqjVdkOVy/UBNvyKzZOke4Q+LWlJxqdgOGo/fj8erh0m6",
	"euidx71eb/XwR/csPo47q4cLVZZKen6uNC3xTulvkCsN7gxcK22LqaplBr6QEam1IH1SWFv1k+Tu7i4+",
	"nlVVrPQsyW2VpBUyk1DNCj7HpHd+a1BzNEkIm7jUuMzVc4QuvouaNY3j+N+qnYk/y9Vf0Ov0OlFA9kHP",
	"qOR/UneeChhTbSVqA28GN6P/RzCYjNIILi7SQQTDSTqKYJJe+n+Tgftz8Tb+LAdCgOazwhrQ6KJhFn+W",
	"JCKWW+EYDiVtm3m7piQic9QmgO/G3bjjclMVSlpxx3jciTskIhW1hS9IQoXYlNs/mqHd0fFNsK3G3uYB",
	"qMxAo9Uc5wgUmBICWTsfwYIxpTPfwAoYaku53NXHbh49faOM9Ml7tIPHCB141xEWtSH9T0+BptYXiWco",
	"Lc8X7cC4QnI5V99QAzWGz+RmND2dwJRGyGvpUccwskCFUaCxckWQ1gTbi6vWN0cNXG48HJ0lZwhcWtQ5",
	"Zehn0iH6XqNekIhIWvp5qfhRg+SIZyQiGr/XXGNG+lbXGDX7ypWgGSjjU3Ijtqs9ndsIuAVuwKB1y+ee",
	"VvyalriEimrbbqiPNyMwVtfM1hqdWYY5dzRwCaaeMkFrg6uHk/jEnXg0m6ed7urhU/d/X15Kyn98NfyS",
	"flUamqZd43yD8SyGefftSwHbTn9VTLdYasmZbzFw5lCbTS84SCH4zfD3j8N0cnszTMcfrtPhXihMleWR",
	"j7sN5PAt/AjpxPnfkc5YK6uYEk+T2Ae2aux/MdYWxs4qD9cjg3pvPTEP0/CKUl5SS912Lqk1e4ro9jwV",
	"zT6GNnn4Lf1w7U/sLWpGLT0Kvn8xVQ71VXC8I6fJEynBqMWZ0gu3NO8KzopnYmOKQsmZAatemhX2JI9/",
	"JPcKqdsTBkxdVUrbDbvXbldKU5eo/d24WaHrSyLd4NsHau32KG8i7eP59F33NsgBR90LqqX12EJ/XVrZ",
	"Whs+opfLzI1gsGvXHKyvoBgmBXfibAFKigVMEZr7Ani+sffJb065Xd2YvVS0f4ejL+4KMpWSJojgXqfj",
	"/jElLUovBWhViWYPJV+N4/H+OYzdzf5YcHtN+Lzh2/AwVdnCNZfTBuG+1WhqYTci22k48D3mvgtu/DuN",
	"M26sr51XZU70nIQ0tkjquoF9gaQ1C4k76110D3DRDS6OD3BxHFycHODiJLg4O8DFmXfRPQBFN6Donf+8",
	"i965c3F6QFFPQ1FPD6jIaahIhjmthf1pN+355dIPhJf4jZgNv2OcgLtRyi6TZhUd0YqbZN51+p5qTqci",
	"zGpjF/R6A8r/CjL9JMEftKwExkyV5OnYNQf3yUB4F5+2KhAmKYQfSrFD/GX5dwAAAP//e/i3vWEPAAA=",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %s", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	var res = make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	pathPrefix := path.Dir(pathToFile)

	for rawPath, rawFunc := range externalRef0.PathToRawSpec(path.Join(pathPrefix, "TS29122_CommonData.yaml")) {
		if _, ok := res[rawPath]; ok {
			// it is not possible to compare functions in golang, so always overwrite the old value
		}
		res[rawPath] = rawFunc
	}
	for rawPath, rawFunc := range externalRef2.PathToRawSpec(path.Join(pathPrefix, "TS29222_CAPIF_Publish_Service_API.yaml")) {
		if _, ok := res[rawPath]; ok {
			// it is not possible to compare functions in golang, so always overwrite the old value
		}
		res[rawPath] = rawFunc
	}
	for rawPath, rawFunc := range externalRef1.PathToRawSpec(path.Join(pathPrefix, "TS29571_CommonData.yaml")) {
		if _, ok := res[rawPath]; ok {
			// it is not possible to compare functions in golang, so always overwrite the old value
		}
		res[rawPath] = rawFunc
	}
	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	var resolvePath = PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		var pathToFile = url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
