// Package providermanagementapi provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen version v1.9.1 DO NOT EDIT.
package providermanagementapi

import (
	"bytes"
	"compress/gzip"
	"encoding/base64"
	"fmt"
	"net/http"
	"net/url"
	"path"
	"strings"

	"github.com/deepmap/oapi-codegen/pkg/runtime"
	"github.com/getkin/kin-openapi/openapi3"
	"github.com/labstack/echo/v4"
	externalRef0 "oransc.org/nonrtric/plt/capif/internal/readonly/common"
	externalRef1 "oransc.org/nonrtric/plt/capif/internal/readonly/common29571"
)

// ServerInterface represents all server handlers.
type ServerInterface interface {

	// (POST /registrations)
	PostRegistrations(ctx echo.Context) error

	// (DELETE /registrations/{registrationId})
	DeleteRegistrationsRegistrationId(ctx echo.Context, registrationId string) error

	// (PUT /registrations/{registrationId})
	PutRegistrationsRegistrationId(ctx echo.Context, registrationId string) error
}

// ServerInterfaceWrapper converts echo contexts to parameters.
type ServerInterfaceWrapper struct {
	Handler ServerInterface
}

// PostRegistrations converts echo context to params.
func (w *ServerInterfaceWrapper) PostRegistrations(ctx echo.Context) error {
	var err error

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostRegistrations(ctx)
	return err
}

// DeleteRegistrationsRegistrationId converts echo context to params.
func (w *ServerInterfaceWrapper) DeleteRegistrationsRegistrationId(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "registrationId" -------------
	var registrationId string

	err = runtime.BindStyledParameterWithLocation("simple", false, "registrationId", runtime.ParamLocationPath, ctx.Param("registrationId"), &registrationId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter registrationId: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.DeleteRegistrationsRegistrationId(ctx, registrationId)
	return err
}

// PutRegistrationsRegistrationId converts echo context to params.
func (w *ServerInterfaceWrapper) PutRegistrationsRegistrationId(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "registrationId" -------------
	var registrationId string

	err = runtime.BindStyledParameterWithLocation("simple", false, "registrationId", runtime.ParamLocationPath, ctx.Param("registrationId"), &registrationId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter registrationId: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PutRegistrationsRegistrationId(ctx, registrationId)
	return err
}

// This is a simple interface which specifies echo.Route addition functions which
// are present on both echo.Echo and echo.Group, since we want to allow using
// either of them for path registration
type EchoRouter interface {
	CONNECT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	DELETE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	GET(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	HEAD(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	OPTIONS(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PATCH(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	POST(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PUT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	TRACE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
}

// RegisterHandlers adds each server route to the EchoRouter.
func RegisterHandlers(router EchoRouter, si ServerInterface) {
	RegisterHandlersWithBaseURL(router, si, "")
}

// Registers handlers, and prepends BaseURL to the paths, so that the paths
// can be served under a prefix.
func RegisterHandlersWithBaseURL(router EchoRouter, si ServerInterface, baseURL string) {

	wrapper := ServerInterfaceWrapper{
		Handler: si,
	}

	router.POST(baseURL+"/registrations", wrapper.PostRegistrations)
	router.DELETE(baseURL+"/registrations/:registrationId", wrapper.DeleteRegistrationsRegistrationId)
	router.PUT(baseURL+"/registrations/:registrationId", wrapper.PutRegistrationsRegistrationId)

}

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/+xY624buRV+FYItsC0wmZHkuAvrn9aXrbBNI1ja9scmMCjyjMQth+SSHDtq4Afqa/TJ",
	"ikPqNtJISqL0gq7/JNbMnPt3vnPIj5SbyhoNOnja/0g9n0PF4p+D0XDkzKMU4G61M6oCHW4gMKnia+uM",
	"BRckxF/MSvz4xlRDgb8FeO6kDdJo2kdVxC51EWEqJjUZ3hDmvZxpEGS6IGEO5HowGt4RbhyQstYchUkw",
	"8RVqqJhmM0A3Nq+f5lIBcTCTPoCTerb+esdeTsZzphTRJpApEOvAoyKpo8AfJ5MRGb0dT4iDX2rwgZTO",
	"VGtdb1osLx1r8TnDd0a/mhrmBJHBgypX5pum8YkJc3DJgaVtT5gWxIG3RnvwOc2oAybearWg/eBqyGhY",
	"WKB96gOGTJ+z7fzr0uxX4HvQ4CQnUpfGVSxG4ECxAGI7xbtF8jWfE+aJSHUnptz/lFmrJI8qo6+HfLur",
	"Nfct2CBK+oCapRbyUYqaqVZfVulde5OTv85BE6m5qsUGRYegsl3qVZUr8J7NICMyRDf8wUxsrIc5CycM",
	"BdDCY15XwCxqK1gA9CE9cqkExpHlm8Zj6wwHUTs4EGJbozTDS9g5Et+hpKbwmNs0FYiNmwIRwcH7slZq",
	"gdWWAapY1d86KGmf/qbYEEqxZJNii0rulgZXTPKc0UrqYdLSXaOHOccW+LJkUt0D84iVXejct6fSW+Cy",
	"lJygbO2gAXpTxscgjla5UQ6ft/XufrKnRiyILAkLChhCWkNrwxyzdQgRZQR8W3c5mI2B7ydnDLx2Miwa",
	"0WvA4jG3IKVxxzj3kSkZvcBvmg6Wpyi2macD1HqoeYJpdQndbUvitmut6fG1tXfAwhZEJ+Pe1eW33Ydr",
	"U1VG37DA8gWrVCtyx7W1xgUQqKN24OlzzPkvtXQgaP+nVf7fr22b6c/AA9o+AvtDAxS/+9QJukrO50/S",
	"g1DcG6eJuP5dc7X6/Lm68u3rzNVjs+qrDtJ1eF97ot4bBSfpN32+wmEUScyxivGY9DbLDjdRtzVCVLfv",
	"XmtvtPi0l+yR8V5OFSAd1eDjWHpFBrd3/WbCNkPQxxe3H6zxCNpV2+UoNjolNqqnSvr5nuCbpeDokODW",
	"frgWfKdpRkHXFeZmcHtHkQ/iv2/utjKyKeqhPB+iimtw4fOI4htPuJLoJUdtJWIMjuBrVE9/gEVLWTBP",
	"nPwAC4RvIzM7FlvQu4Oapql9pOD38CGA00zdmLYF8uL70YhMxqR3lfd6PfKX7h/yi7xDErtH7+4cq+DJ",
	"uL/FMRK//7NxYT41tY57gKcZrZ2ifToPwfaL4unpKb+YWZsbNyvKYIuxBe4L5vhcPkLRu3rw4CT4Ihkt",
	"MGmylS/Q/qHhtVm+NkSYv9P//AfpdXqdLHn61s2Yln+PWGCKjJgLGpwnvxvcD7/LyGAyHGfk+no8yMjt",
	"ZDzMyGR8E/+bDPCf69/n7/RAKeLkbB480h+4RxAJn0EG7Dsa2fZhMBo+rCr5sME0PqcZfQTnU0zdvJN3",
	"MGRjQTMrsQjxUUYtC/NYo6KxQUUQGx8O7XAYECManlrR9CTD/EQCrTOlVInUsVdSF4nEIeG+4UsCIPjw",
	"nRER3dzgxh5Sb62pt/h5uXQmIvyMHXfvuPzcRD2e4eKD5SRC1b1O9z/nymnK2Fr+tzd+mtE5MAEu+vwn",
	"w9cU1VR5bXRgUqfjxo/3w9WY0/CkFoQ7iPPSgTe145ARxrlxIq4ZaYb64GqOC1effGRW3hsTngtm5auV",
	"o682LVM8dptoKz5u/xyKZ7qb/Wwrk7v8hAl63ensLIzdXu/owrguZoGyUUX3DBXdpOLiDBUXScXrM1S8",
	"jiq6ZwTSTYF0zwikmwLpXp6h4jKq6F19uYreFaq4PAMXlwkXl2cU9TIVVUDJahW+WM1KPmH9VO/E5lYQ",
	"WvazG3Br+m5jkemCRFFs7Lb3uI+vOXyfum+i2QZ5N5YkEQcODvcQGemnvTNw7GkiBeggywX+zRrc1k59",
	"iZUojnTajyONZlSzCmnC7Trw6cTyfo/yX++ndHLgAFGxwONm2nQAN9BUHZHTF+JqEtdLv+/1e0Zt3bKF",
	"/RivnPCA3Aa+b3zzCmh1/7q/a9Xh/6tb/wtrYjMnDpbXGqcu31orhNvUFNZ3t1K3XavQ06tp539vNd0J",
	"tO16+oUPXxa5X88i95zReLJfUmu6zviUsxMe7ZmTbKrW10sokobE0r94L+L7RQEfWGUV5NxUdLdZl4Lp",
	"drOUOjGOr6dcsdoD+Ta/RAJr3teg7++f/xUAAP///pFxU4ceAAA=",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %s", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	var res = make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	pathPrefix := path.Dir(pathToFile)

	for rawPath, rawFunc := range externalRef0.PathToRawSpec(path.Join(pathPrefix, "TS29122_CommonData.yaml")) {
		if _, ok := res[rawPath]; ok {
			// it is not possible to compare functions in golang, so always overwrite the old value
		}
		res[rawPath] = rawFunc
	}
	for rawPath, rawFunc := range externalRef1.PathToRawSpec(path.Join(pathPrefix, "TS29571_CommonData.yaml")) {
		if _, ok := res[rawPath]; ok {
			// it is not possible to compare functions in golang, so always overwrite the old value
		}
		res[rawPath] = rawFunc
	}
	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	var resolvePath = PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		var pathToFile = url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
