// Package publishserviceapi provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen version v1.9.1 DO NOT EDIT.
package publishserviceapi

import (
	"bytes"
	"compress/gzip"
	"encoding/base64"
	"fmt"
	"net/http"
	"net/url"
	"path"
	"strings"

	"github.com/deepmap/oapi-codegen/pkg/runtime"
	"github.com/getkin/kin-openapi/openapi3"
	"github.com/labstack/echo/v4"
	externalRef0 "oransc.org/nonrtric/plt/capif/internal/readonly/common"
	externalRef1 "oransc.org/nonrtric/plt/capif/internal/readonly/common29571"
)

// ServerInterface represents all server handlers.
type ServerInterface interface {

	// (GET /{apfId}/service-apis)
	GetApfIdServiceApis(ctx echo.Context, apfId ApfId) error

	// (POST /{apfId}/service-apis)
	PostApfIdServiceApis(ctx echo.Context, apfId ApfId) error

	// (DELETE /{apfId}/service-apis/{serviceApiId})
	DeleteApfIdServiceApisServiceApiId(ctx echo.Context, apfId ApfId, serviceApiId ServiceApiId) error

	// (GET /{apfId}/service-apis/{serviceApiId})
	GetApfIdServiceApisServiceApiId(ctx echo.Context, apfId ApfId, serviceApiId ServiceApiId) error

	// (PUT /{apfId}/service-apis/{serviceApiId})
	PutApfIdServiceApisServiceApiId(ctx echo.Context, apfId ApfId, serviceApiId ServiceApiId) error
}

// ServerInterfaceWrapper converts echo contexts to parameters.
type ServerInterfaceWrapper struct {
	Handler ServerInterface
}

// GetApfIdServiceApis converts echo context to params.
func (w *ServerInterfaceWrapper) GetApfIdServiceApis(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "apfId" -------------
	var apfId ApfId

	err = runtime.BindStyledParameterWithLocation("simple", false, "apfId", runtime.ParamLocationPath, ctx.Param("apfId"), &apfId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter apfId: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetApfIdServiceApis(ctx, apfId)
	return err
}

// PostApfIdServiceApis converts echo context to params.
func (w *ServerInterfaceWrapper) PostApfIdServiceApis(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "apfId" -------------
	var apfId ApfId

	err = runtime.BindStyledParameterWithLocation("simple", false, "apfId", runtime.ParamLocationPath, ctx.Param("apfId"), &apfId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter apfId: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostApfIdServiceApis(ctx, apfId)
	return err
}

// DeleteApfIdServiceApisServiceApiId converts echo context to params.
func (w *ServerInterfaceWrapper) DeleteApfIdServiceApisServiceApiId(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "apfId" -------------
	var apfId ApfId

	err = runtime.BindStyledParameterWithLocation("simple", false, "apfId", runtime.ParamLocationPath, ctx.Param("apfId"), &apfId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter apfId: %s", err))
	}

	// ------------- Path parameter "serviceApiId" -------------
	var serviceApiId ServiceApiId

	err = runtime.BindStyledParameterWithLocation("simple", false, "serviceApiId", runtime.ParamLocationPath, ctx.Param("serviceApiId"), &serviceApiId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter serviceApiId: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.DeleteApfIdServiceApisServiceApiId(ctx, apfId, serviceApiId)
	return err
}

// GetApfIdServiceApisServiceApiId converts echo context to params.
func (w *ServerInterfaceWrapper) GetApfIdServiceApisServiceApiId(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "apfId" -------------
	var apfId ApfId

	err = runtime.BindStyledParameterWithLocation("simple", false, "apfId", runtime.ParamLocationPath, ctx.Param("apfId"), &apfId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter apfId: %s", err))
	}

	// ------------- Path parameter "serviceApiId" -------------
	var serviceApiId ServiceApiId

	err = runtime.BindStyledParameterWithLocation("simple", false, "serviceApiId", runtime.ParamLocationPath, ctx.Param("serviceApiId"), &serviceApiId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter serviceApiId: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetApfIdServiceApisServiceApiId(ctx, apfId, serviceApiId)
	return err
}

// PutApfIdServiceApisServiceApiId converts echo context to params.
func (w *ServerInterfaceWrapper) PutApfIdServiceApisServiceApiId(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "apfId" -------------
	var apfId ApfId

	err = runtime.BindStyledParameterWithLocation("simple", false, "apfId", runtime.ParamLocationPath, ctx.Param("apfId"), &apfId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter apfId: %s", err))
	}

	// ------------- Path parameter "serviceApiId" -------------
	var serviceApiId ServiceApiId

	err = runtime.BindStyledParameterWithLocation("simple", false, "serviceApiId", runtime.ParamLocationPath, ctx.Param("serviceApiId"), &serviceApiId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter serviceApiId: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PutApfIdServiceApisServiceApiId(ctx, apfId, serviceApiId)
	return err
}

// This is a simple interface which specifies echo.Route addition functions which
// are present on both echo.Echo and echo.Group, since we want to allow using
// either of them for path registration
type EchoRouter interface {
	CONNECT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	DELETE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	GET(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	HEAD(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	OPTIONS(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PATCH(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	POST(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PUT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	TRACE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
}

// RegisterHandlers adds each server route to the EchoRouter.
func RegisterHandlers(router EchoRouter, si ServerInterface) {
	RegisterHandlersWithBaseURL(router, si, "")
}

// Registers handlers, and prepends BaseURL to the paths, so that the paths
// can be served under a prefix.
func RegisterHandlersWithBaseURL(router EchoRouter, si ServerInterface, baseURL string) {

	wrapper := ServerInterfaceWrapper{
		Handler: si,
	}

	router.GET(baseURL+"/:apfId/service-apis", wrapper.GetApfIdServiceApis)
	router.POST(baseURL+"/:apfId/service-apis", wrapper.PostApfIdServiceApis)
	router.DELETE(baseURL+"/:apfId/service-apis/:serviceApiId", wrapper.DeleteApfIdServiceApisServiceApiId)
	router.GET(baseURL+"/:apfId/service-apis/:serviceApiId", wrapper.GetApfIdServiceApisServiceApiId)
	router.PUT(baseURL+"/:apfId/service-apis/:serviceApiId", wrapper.PutApfIdServiceApisServiceApiId)

}

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/+xa4VLjOPJ/FZX+/w9QZRwcYLYm3zIhzGaZIz5stupq2aIUu0O040g+SQ6To/Iu8/Ve",
	"gye7kmQ7TiJCgLnduRq+gLGkVrfU/ft1t7nHCZ/mnAFTEnfusUwmMCXmsQvjUPAxzUD/lQueg1AUzBiB",
	"8SDVDynIRNBcUc5wBw9SYIqOKQjEx0hNAHXDAYIvOZeU3aJxwRIz08NqngPuYKkEZbd44eGUKHLGxZQo",
	"Lfb/BYxxB/9fa6ldq1StdbqcqdfxKaHsgkxhU51TM4YUR3cTmkyMMiPIOLuVSHGXFpQpEGOSwOlSkHTY",
	"WU1DKShCM4k9TBVM5VO6Dxzy9b5TygZ2fVBrRYQgcz2YC654wrOnhIfVvIWHJSSFoGr+N1ATnjpMiMoJ",
	"aGpnIFnkORcKUjSa26vrn+1qVrSy25MGzUBI98HqGypHd93713L69k0XHhbwz4IKSHHnt9J/G5r8Xi/g",
	"oz8gMa7V49NpwWhCtHKxGV3XN+RS0lEGaEayAiQiAtABuuz//aofxTeX/SgcXkT9DoongJKmOERlFSJ6",
	"X6SVA6kOBMicM6mlRFcfot7l4EP/5mIYD87+sYMUWYy0diM4YFzR8fxanyKwYqptXtcKe3h9i8YxLGOi",
	"V0jFp8McBLFWr4OBVqk6nm03tXmeCw8nhVTD3B2/VGkDJShEJLpfzlygnAhVWX51OUBSiSJRhQA05gIR",
	"lBidEa+URndUTXihkADJC5EAIlLyhNpBIlEKY8ogRZTpQ0wyUkh4+HrsH+tdjj6G4cPXOHr42n7vnxwG",
	"vhPAmqqvWxLDF4Uaryrd1/V0Ca4HXVFcB+3PcRzWsawPoULfymIfDVk2RyTPM5oQ7bN3E2BmWgUw2vol",
	"6iPKUn1ZII1wf9eAXHrKs0Ky9qIVn3DF5ekKVewSkL9Ew4sO+oXMSGTmoqERhi64MpquxIme7AwEJ3hv",
	"RAPNZ8fdNBWNY4qj9vug3b7RAcCZVt+fk2nmZohquWajfPbudaLeVaK0l7xQTKiXfhtKqenVQ1QhRT5r",
	"34MEUmAJID4D67ZyXVAu+IymNjyXDuqVfq4xIoeEjmmy3MH/r3DXwuGOK8i4izd+7McdG68f+3FpIzpA",
	"4TCq3uvHxsBV/f6q+bob936uBvTzcui0/6kf98sx+0c5uOLpH/sx9rDeTP+6Mj+1IOxhu8gZBmEjHdnF",
	"XK3ETXATlOqUlIsCP6gG22tD7RUtq/XYs49tt1bFKKNyAmk3pyFREwdNJeOBy227KKPSsEmvd4ZoncJK",
	"DZACSo8UM5pYQKUSkUwASecorzZd8bYN3Z7pUJclYv9vMm1FrJAa0kWkybl/Fc82ifBH4lhNsVY1971X",
	"roaYHnYcTCGoa1VGFJ1Zh3CcsEH3hj+RnEYlQFcbXgkaEqG2+dc38Ja1FGPlLLxmxqHNdKUaa+SwI+KF",
	"0XkHrbEhCtDelamC40/RQRid71sDbb5uTNQGoThCR0d+0G5rOeeDTTntSk54PthBxrB7Ff+8KeUI7cWf",
	"Ihuhw26hJkjxz8CeErgCzGF0rhnjfIA9bLZxAnNkobMbDramTaSOCRdE9890AJURMza5H+XMK+t6ypKs",
	"SEEaJzLdBkiNQ5bVOdoD/9avQ3B/5zBrtECeijOSU1dHxBDGsitCpKS3bJkQ9brh4AwlXMNp2RxBilvA",
	"qLilST4+iiYkyxDjCo1M8iSBKX1PeskydyjLSTQWfFqHZymx2YmpNnPoUW21fZuyWq332WLQYyoQlq5I",
	"1knRswVTNuOfQaC9lMpEJ5Jz/XrfySAkp2401II0EDrw6yky/CbUpnGyyPMzIEquJesnPwU7Jes1WWkh",
	"hQBpmD9xdutcR7r01W9Kvi5ZeTFq5GpbG1vruZ2pRipY6REFt1zMnamXnBABmokHbMyfLAWak0uMMUI2",
	"DvWbXc56X6p0TScXubTbTBFJTjVozU751IGkn6pU19x9WVcJZLuoctkq3Uh6l3vqSSNA5mRfnvh6mMra",
	"IlctqfQ+11iJAq5xI09SE6I21CMsbXGx8TopXQMlhC11rnAj23YWTYt9NFQTEHdUgsEEo9iYZBKucSNM",
	"RpxnQNjGpTYNdV1s1cHc5MScNsY2sWpK/uCirpooM5hkuW4W7Ltizmb2j+e6vbVsXm5tnO3Mo+stxKdc",
	"A77k1Ab0C6LslCiI6RSa2a98PPV1db7Dwc6m1cXa8/rPy5t1eQTJt35eKZu/jczbwatO/K5Q052sRGZe",
	"xQFz/UyYCb0ZTQuSPZKTOPJuc4cKBCPZKU8cp7/Ch+12++Hrr8E7/8g/fPhq79iYdSbIFO64+GyqLZOK",
	"XnChJiNeMJPhSZO7Z7iDJ0rlnVbr7u7OP7rNc5+L29ZY5S1deMgWEcmEzqDVfn8jQVCQLbtty370sdSw",
	"GWB618bRNoyW/jV7+DdqH7YPPavYUNwSRv9lroZkSFc3DIREe93LwQcPdeNB5KFeL+p6qB9HAw/F0an5",
	"FXf1j96+f826WYYEvZ0oqeMNxAxS36TciiqNkpayb0o+vClT6xtLsNV3kw4O/MA/LMtaRnKqz9s/9A+x",
	"h3OiJuY6WvfGyRat0qgDklMzcAvKFSxKUJgB0hnh0gvMQeBG+ay9Cn8E1dWyo9rZpNlZX6YCIXHnt3tM",
	"tVitDfawKT47pdc3A0WDv1d+k3wqEO3qxeJ3E/UmezT2tA8PbeuEKWDKwqopz7W+rT+kBdfd9nDXMsbd",
	"17486lyQVlGqD63hO3tyv3GGS8xxR/HCw8fWhGf0busTaOm1RkTwChGBFXH0ChFHVsTxK0QcWxHvXiHi",
	"nRHRfv9yEe33WsTJK27kxN7IySuO88QeZwpjUmTqxWKq9caBcy5d31OsSyKCGNxVaL8a7iGXf3m8m2r3",
	"A0/nf0aor+q72MCb4M/Hm6iR9DZIukgSkHJcZNncfDxu9OsSAaZHW+d1sqr2BahClIWsnnmNP3Gr/TW2",
	"FfoESGoLRPtk7K4mOZJKzpStLlZVYHCXzTcU8RBJEi5SjYJlol6X2R1Ti19yrhat2kzDXK1Z4GS01n0z",
	"5Vls9baNJOYNelehN3iFIYE1JHiFIYE1JDh5hYiTNwJwE8DCwzsFkInuDJSjZr9iec0Wj1YKq9xxakSt",
	"s0fUrFJ2YRK5uuBlhLIiZLHw/tQc9djRTpvAk7UXmhKVmISx0frohnSQIiqRvaj0LYdcB7K3+HckgE8U",
	"fruGtKP6+wHj+XurOd8KzreC83srOAsH3lzlKVHPQJuw+EHR5ruqeP9ytGsiXWFcaLX6fUO1t1ruB6rl",
	"yi89FebZLyRbWifYwzMiKBll9YdHPdPCc6mW+cIiO60WfCHTPAM/4VO8HpXlwsf+HQL95J9U/w2B4gjZ",
	"jzC+1vn3xX8CAAD//050e7qLNAAA",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %s", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	var res = make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	pathPrefix := path.Dir(pathToFile)

	for rawPath, rawFunc := range externalRef0.PathToRawSpec(path.Join(pathPrefix, "TS29122_CommonData.yaml")) {
		if _, ok := res[rawPath]; ok {
			// it is not possible to compare functions in golang, so always overwrite the old value
		}
		res[rawPath] = rawFunc
	}
	for rawPath, rawFunc := range externalRef1.PathToRawSpec(path.Join(pathPrefix, "TS29571_CommonData.yaml")) {
		if _, ok := res[rawPath]; ok {
			// it is not possible to compare functions in golang, so always overwrite the old value
		}
		res[rawPath] = rawFunc
	}
	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	var resolvePath = PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		var pathToFile = url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
