


from flask import Flask, request, Response
from time import sleep
import time
from datetime import datetime
import json
import traceback

app = Flask(__name__)

# Server info
HOST_IP = "::"
HOST_PORT = 8080

CALLBACK_URL="/callbacks/<string:id>"

MIME_TEXT="text/plain"
MIME_JSON="application/json"
CAUGHT_EXCEPTION="Caught exception: "
SERVER_ERROR="Server error :"
TIME_STAMP="cr-timestamp"

#I'm alive function
@app.route('/',
    methods=['GET'])
def index():
    return 'OK', 200


# Receive a callback message
# URI and payload, (PUT or POST): /callbacks/<id> <json messages>
# response: OK 200 or 500 for other errors
@app.route(CALLBACK_URL,
    methods=['PUT','POST'])
def events_write(id):

    try:
        print("Received callback for id: "+id +", content-type="+request.content_type)
        print("raw data: str(request.data): "+str(request.data))
        try:
            if (request.content_type == MIME_JSON):
                data = request.data
                msg = json.loads(data)
                print("Payload(json): "+str(msg))
                if (isinstance(msg, list)):
                    print("payload is list, extracting first entry only")
                    msg=json.loads(msg[0])
                f = open("/rapp/dump/"+id+".json", "w")
                f.write(json.dumps(msg))
                f.close()
            else:
                msg={}
                print("Payload(content-type="+request.content_type+"). Setting empty json as payload")
        except Exception as e:
            msg={}
            print("(Exception) Payload does not contain any json, setting empty json as payload")
            traceback.print_exc()

    except Exception as e:
        print(CAUGHT_EXCEPTION+str(e))
        traceback.print_exc()
        return 'NOTOK',500

    return 'OK',200


### Main function ###

if __name__ == "__main__":
    app.run(port=HOST_PORT, host=HOST_IP)

# from http.server import BaseHTTPRequestHandler, HTTPServer # python3
# class HandleRequests(BaseHTTPRequestHandler):
#     def _set_headers(self):
#         self.send_response(200)
#         self.send_header('Content-type', 'text/html')
#         self.end_headers()

#     def do_GET(self):
#         self._set_headers()
#         self.wfile.write("received get request")

#     def do_POST(self):
#         '''Reads post request body'''
#         self._set_headers()
#         content_len = int(self.headers.getheader('content-length', 0))
#         post_body = self.rfile.read(content_len)
#         self.wfile.write("received post request:<br>{}".format(post_body))
#         print(post_body)

#     def do_PUT(self):
#         self.do_POST()

# host = ''
# port = 8080
# HTTPServer((host, port), HandleRequests).serve_forever()

# import http.server

# class Handler(http.server.SimpleHTTPRequestHandler) :
#         # A new Handler is created for every incommming request tho do_XYZ
#         # methods correspond to different HTTP methods.

#         def do_GET(s) :
#                 print('-----------------------')
#                 print('GET %s (from client %s)' % (s.path, s.client_address))
#                 print(s.headers)

#                 super(Handler, s).do_GET() #inherited do_GET serves dirs&files.

# s = http.server.HTTPServer( ('', 8080), Handler )
# s.serve_forever()